diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelBase.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelBase.java
index 714fada2c..94ddaedc3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelBase.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelBase.java
@@ -1,31 +1,28 @@
 package net.minecraft.client.render.model;
 
 import net.minecraft.core.entity.Mob;
+import org.jetbrains.annotations.Nullable;
 
 public abstract class ModelBase
 {
 
+    public float swingProgress;
+    public boolean isRiding;
+
     public ModelBase()
     {
         isRiding = false;
     }
 
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
     }
 
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
-    {
-    }
-
-    public void setLivingAnimations(Mob mob, float limbSwing, float limbYaw, float partialTick)
+    protected void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
     }
 
     public void onUnload(){
 
     }
-
-    public float onGround;
-    public boolean isRiding;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelBiped.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelBiped.java
index ac7602a22..ff4ce45b5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelBiped.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelBiped.java
@@ -1,6 +1,9 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.IItemHolding;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 public class ModelBiped extends ModelBase
 {
@@ -64,9 +67,9 @@ public class ModelBiped extends ModelBase
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         head.render(scale);
         body.render(scale);
         armRight.render(scale);
@@ -77,7 +80,7 @@ public class ModelBiped extends ModelBase
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
         head.yRot = headYaw / 57.29578F; // 1 rad
         head.xRot = headPitch / 57.29578F; // 1 rad
@@ -115,26 +118,54 @@ public class ModelBiped extends ModelBase
         }
         armRight.yRot = 0.0F;
         armLeft.yRot = 0.0F;
-        if(onGround > -9990F)
+        if(swingProgress > -9990F)
         {
-            float f6 = onGround;
-            body.yRot = MathHelper.sin(MathHelper.sqrt_float(f6) * MathHelper.PI * 2.0F) * 0.2F;
-            armRight.z = MathHelper.sin(body.yRot) * 5F;
-            armRight.x = -MathHelper.cos(body.yRot) * 5F;
-            armLeft.z = -MathHelper.sin(body.yRot) * 5F;
-            armLeft.x = MathHelper.cos(body.yRot) * 5F;
-            armRight.yRot += body.yRot;
-            armLeft.yRot += body.yRot;
-            armLeft.xRot += body.xRot;
-            f6 = 1.0F - onGround;
-            f6 *= f6;
-            f6 *= f6;
-            f6 = 1.0F - f6;
-            float f7 = MathHelper.sin(f6 * MathHelper.PI);
-            float f8 = MathHelper.sin(onGround * MathHelper.PI) * -(head.xRot - 0.7F) * 0.75F;
-            armRight.xRot -= (double)f7 * 1.2D + (double)f8;
-            armRight.yRot += body.yRot * 2.0F;
-            armRight.zRot = MathHelper.sin(onGround * MathHelper.PI) * -0.4F;
+            if (mob instanceof IItemHolding && ((IItemHolding) mob).isLeftHanded()) {
+                body.yRot = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * -2.0F) * 0.2F;
+                armRight.z = MathHelper.sin(body.yRot) * 5F;
+                armRight.x = -MathHelper.cos(body.yRot) * 5F;
+                armRight.yRot += body.yRot;
+                armRight.xRot += body.xRot;
+
+                armLeft.z = -MathHelper.sin(body.yRot) * 5F;
+                armLeft.x = MathHelper.cos(body.yRot) * 5F;
+                armLeft.yRot += body.yRot;
+                armLeft.xRot += body.xRot;
+
+                float f6 = 1.0F - swingProgress;
+                f6 *= f6;
+                f6 *= f6;
+                f6 = 1.0F - f6;
+                float f7 = MathHelper.sin(f6 * MathHelper.PI);
+                float f8 = MathHelper.sin(swingProgress * MathHelper.PI) * -(head.xRot - 0.7F) * 0.75F;
+
+                armLeft.xRot -= (double)f7 * 1.2D + (double)f8;
+                armLeft.yRot += body.yRot * 2.0F;
+                armLeft.zRot = MathHelper.sin(swingProgress * MathHelper.PI) * 0.4F;
+            } else {
+                body.yRot = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F;
+                armRight.z = MathHelper.sin(body.yRot) * 5F;
+                armRight.x = -MathHelper.cos(body.yRot) * 5F;
+                armRight.yRot += body.yRot;
+                armRight.xRot += body.xRot;
+
+                armLeft.z = -MathHelper.sin(body.yRot) * 5F;
+                armLeft.x = MathHelper.cos(body.yRot) * 5F;
+                armLeft.yRot += body.yRot;
+                armLeft.xRot += body.xRot;
+
+                float f6 = 1.0F - swingProgress;
+                f6 *= f6;
+                f6 *= f6;
+                f6 = 1.0F - f6;
+                float f7 = MathHelper.sin(f6 * MathHelper.PI);
+                float f8 = MathHelper.sin(swingProgress * MathHelper.PI) * -(head.xRot - 0.7F) * 0.75F;
+
+                armRight.xRot -= (double)f7 * 1.2D + (double)f8;
+                armRight.yRot += body.yRot * 2.0F;
+                armRight.zRot = MathHelper.sin(swingProgress * MathHelper.PI) * -0.4F;
+            }
+
         }
         if(sneaking)
         {
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelBoat.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelBoat.java
index d4aab5c8b..1ec5b8b43 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelBoat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelBoat.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 public class ModelBoat extends ModelBase
 {
@@ -34,13 +36,12 @@ public class ModelBoat extends ModelBase
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
         for(int i = 0; i < 5; i++)
         {
             boatSides[i].render(scale);
         }
-
     }
 
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelCannonball.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelCannonball.java
index 0ecd1d5a5..4f36e71a7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelCannonball.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelCannonball.java
@@ -1,8 +1,13 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
+import org.jetbrains.annotations.Nullable;
+
 public class ModelCannonball extends ModelBase
 {
 
+    public Cube ball;
+
     public ModelCannonball()
     {
         ball = new Cube(0, 0);
@@ -11,16 +16,9 @@ public class ModelCannonball extends ModelBase
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
         ball.render(scale);
-
     }
 
-    @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
-    {
-    }
-
-    public Cube ball;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelChicken.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelChicken.java
index 25220c7fd..85e39f891 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelChicken.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelChicken.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 public class ModelChicken extends ModelBase
 {
@@ -44,9 +46,9 @@ public class ModelChicken extends ModelBase
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         head.render(scale);
         bill.render(scale);
         chin.render(scale);
@@ -58,7 +60,7 @@ public class ModelChicken extends ModelBase
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
         head.xRot = headPitch / 57.29578F;
         head.yRot = headYaw / 57.29578F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelCow.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelCow.java
index 87c5fc0eb..ec1ede7d9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelCow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelCow.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 public class ModelCow extends ModelQuadruped
 {
@@ -39,18 +41,18 @@ public class ModelCow extends ModelQuadruped
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        super.render(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        super.render(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         horn1.render(scale);
         horn2.render(scale);
         udders.render(scale);
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        super.setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         horn1.yRot = head.yRot;
         horn1.xRot = head.xRot;
         horn2.yRot = head.yRot;
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelCreeper.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelCreeper.java
index bfc1e5cb6..8b44b1ec7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelCreeper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelCreeper.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 public class ModelCreeper extends ModelBase
 {
@@ -45,9 +47,9 @@ public class ModelCreeper extends ModelBase
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         head.render(scale);
         body.render(scale);
         leg1.render(scale);
@@ -57,7 +59,7 @@ public class ModelCreeper extends ModelBase
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
         head.yRot = headYaw / 57.29578F;
         head.xRot = headPitch / 57.29578F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelGhast.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelGhast.java
index e790acf0f..eae274de4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelGhast.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelGhast.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -33,7 +35,7 @@ public class ModelGhast extends ModelBase
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
         for(int i = 0; i < tentacles.length; i++)
         {
@@ -43,9 +45,9 @@ public class ModelGhast extends ModelBase
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         body.render(scale);
         for (Cube tentacle : tentacles) {
             tentacle.render(scale);
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelMinecart.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelMinecart.java
index 22c59dd25..45e22d331 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelMinecart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelMinecart.java
@@ -1,10 +1,14 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 public class ModelMinecart extends ModelBase
 {
 
+    public Cube[] sideModels;
+
     public ModelMinecart()
     {
         sideModels = new Cube[7];
@@ -18,18 +22,18 @@ public class ModelMinecart extends ModelBase
         byte byte1 = 8;
         byte byte2 = 16;
         byte byte3 = 4;
-        sideModels[0].addBox(-byte0 / 2, -byte2 / 2, -1F, byte0, byte2, 2, 0.0F);
+        sideModels[0].addBox(-byte0 / 2f, -byte2 / 2f, -1F, byte0, byte2, 2, 0.0F);
         sideModels[0].setRotationPoint(0.0F, 0 + byte3, 0.0F);
-        sideModels[5].addBox(-byte0 / 2 + 1, -byte2 / 2 + 1, -1F, byte0 - 2, byte2 - 2, 1, 0.0F);
+        sideModels[5].addBox(-byte0 / 2f + 1, -byte2 / 2f + 1, -1F, byte0 - 2, byte2 - 2, 1, 0.0F);
         sideModels[5].setRotationPoint(0.0F, 0 + byte3, 0.0F);
-        sideModels[1].addBox(-byte0 / 2 + 2, -byte1 - 1, -1F, byte0 - 4, byte1, 2, 0.0F);
+        sideModels[1].addBox(-byte0 / 2f + 2, -byte1 - 1, -1F, byte0 - 4, byte1, 2, 0.0F);
         sideModels[1].setRotationPoint(-byte0 / 2 + 1, 0 + byte3, 0.0F);
-        sideModels[2].addBox(-byte0 / 2 + 2, -byte1 - 1, -1F, byte0 - 4, byte1, 2, 0.0F);
+        sideModels[2].addBox(-byte0 / 2f + 2, -byte1 - 1, -1F, byte0 - 4, byte1, 2, 0.0F);
         sideModels[2].setRotationPoint(byte0 / 2 - 1, 0 + byte3, 0.0F);
-        sideModels[3].addBox(-byte0 / 2 + 2, -byte1 - 1, -1F, byte0 - 4, byte1, 2, 0.0F);
-        sideModels[3].setRotationPoint(0.0F, 0 + byte3, -byte2 / 2 + 1);
-        sideModels[4].addBox(-byte0 / 2 + 2, -byte1 - 1, -1F, byte0 - 4, byte1, 2, 0.0F);
-        sideModels[4].setRotationPoint(0.0F, 0 + byte3, byte2 / 2 - 1);
+        sideModels[3].addBox(-byte0 / 2f + 2, -byte1 - 1, -1F, byte0 - 4, byte1, 2, 0.0F);
+        sideModels[3].setRotationPoint(0.0F, 0 + byte3, -byte2 / 2f + 1);
+        sideModels[4].addBox(-byte0 / 2f + 2, -byte1 - 1, -1F, byte0 - 4, byte1, 2, 0.0F);
+        sideModels[4].setRotationPoint(0.0F, 0 + byte3, byte2 / 2f - 1);
         sideModels[0].xRot = MathHelper.PI / 2F;
         sideModels[1].yRot = MathHelper.PI * 1.5F;
         sideModels[2].yRot = MathHelper.PI / 2F;
@@ -38,7 +42,7 @@ public class ModelMinecart extends ModelBase
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
         sideModels[5].y = 4F - limbPitch;
         for(int i = 0; i < 6; i++)
@@ -49,9 +53,7 @@ public class ModelMinecart extends ModelBase
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
     }
-
-    public Cube sideModels[];
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelPig.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelPig.java
index e27fb305f..f8591d002 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelPig.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelPig.java
@@ -1,7 +1,11 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
+import org.jetbrains.annotations.Nullable;
+
 public class ModelPig extends ModelQuadruped
 {
+    public Cube nose;
 
     public ModelPig()
     {
@@ -17,17 +21,15 @@ public class ModelPig extends ModelQuadruped
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale) {
-        super.render(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick) {
+        super.render(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         nose.render(scale);
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale) {
-        super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick) {
+        super.setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         nose.xRot = headPitch / 57.29578F;
         nose.yRot = headYaw / 57.29578F;
     }
-
-    public Cube nose;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelPigman.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelPigman.java
new file mode 100644
index 000000000..cfda6a811
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelPigman.java
@@ -0,0 +1,38 @@
+package net.minecraft.client.render.model;
+
+import net.minecraft.core.entity.Mob;
+import org.jetbrains.annotations.Nullable;
+
+public class ModelPigman extends ModelBiped {
+    public Cube nose;
+
+    public ModelPigman()
+    {
+        this(0.0F);
+    }
+
+    public ModelPigman(float yRotOffset)
+    {
+        this(6, yRotOffset);
+    }
+
+    public ModelPigman(float expansion, float yRotOffset) {
+        super(expansion, yRotOffset);
+        nose = new Cube(24, 0);
+        nose.addBox(-2.0F, -4.0F, -5.0F, 4, 3, 1);
+        nose.setRotationPoint(0.0F, 0, 0);
+    }
+
+    @Override
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick) {
+        super.render(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
+        nose.render(scale);
+    }
+
+    @Override
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick) {
+        super.setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
+        nose.xRot = headPitch / 57.29578F;
+        nose.yRot = headYaw / 57.29578F;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelPlayer.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelPlayer.java
index 96d2c46a6..4a8a0aa1b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelPlayer.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class ModelPlayer extends ModelBiped {
@@ -61,8 +63,8 @@ public class ModelPlayer extends ModelBiped {
     }
 
     @Override
-	public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale){
-        super.render(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+	public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick){
+        super.render(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         GL11.glPushMatrix();
         bipedLeftArmOverlay.render(scale);
         bipedRightArmOverlay.render(scale);
@@ -73,8 +75,8 @@ public class ModelPlayer extends ModelBiped {
     }
 
     @Override
-	public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale){
-        super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+	public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick){
+        super.setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         copyTranslation(this.legLeft, this.bipedLeftLegOverlay);
         copyTranslation(this.legRight, this.bipedRightLegOverlay);
         copyTranslation(this.armLeft, this.bipedLeftArmOverlay);
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelQuadruped.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelQuadruped.java
index 0c37640c4..be0dda713 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelQuadruped.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelQuadruped.java
@@ -1,36 +1,44 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 public class ModelQuadruped extends ModelBase
 {
+    public Cube head;
+    public Cube body;
+    public Cube leg1;
+    public Cube leg2;
+    public Cube leg3;
+    public Cube leg4;
 
-    public ModelQuadruped(int i, float f)
+    public ModelQuadruped(int heightOffset, float expand)
     {
         head = new Cube(0, 0);
-        head.addBox(-4F, -4F, -8F, 8, 8, 8, f);
-        head.setRotationPoint(0.0F, 18 - i, -6F);
+        head.addBox(-4F, -4F, -8F, 8, 8, 8, expand);
+        head.setRotationPoint(0.0F, 18 - heightOffset, -6F);
         body = new Cube(28, 8);
-        body.addBox(-5F, -10F, -7F, 10, 16, 8, f);
-        body.setRotationPoint(0.0F, 17 - i, 2.0F);
+        body.addBox(-5F, -10F, -7F, 10, 16, 8, expand);
+        body.setRotationPoint(0.0F, 17 - heightOffset, 2.0F);
         leg1 = new Cube(0, 16);
-        leg1.addBox(-2F, 0.0F, -2F, 4, i, 4, f);
-        leg1.setRotationPoint(-3F, 24 - i, 7F);
+        leg1.addBox(-2F, 0.0F, -2F, 4, heightOffset, 4, expand);
+        leg1.setRotationPoint(-3F, 24 - heightOffset, 7F);
         leg2 = new Cube(0, 16);
-        leg2.addBox(-2F, 0.0F, -2F, 4, i, 4, f);
-        leg2.setRotationPoint(3F, 24 - i, 7F);
+        leg2.addBox(-2F, 0.0F, -2F, 4, heightOffset, 4, expand);
+        leg2.setRotationPoint(3F, 24 - heightOffset, 7F);
         leg3 = new Cube(0, 16);
-        leg3.addBox(-2F, 0.0F, -2F, 4, i, 4, f);
-        leg3.setRotationPoint(-3F, 24 - i, -5F);
+        leg3.addBox(-2F, 0.0F, -2F, 4, heightOffset, 4, expand);
+        leg3.setRotationPoint(-3F, 24 - heightOffset, -5F);
         leg4 = new Cube(0, 16);
-        leg4.addBox(-2F, 0.0F, -2F, 4, i, 4, f);
-        leg4.setRotationPoint(3F, 24 - i, -5F);
+        leg4.addBox(-2F, 0.0F, -2F, 4, heightOffset, 4, expand);
+        leg4.setRotationPoint(3F, 24 - heightOffset, -5F);
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         head.render(scale);
         body.render(scale);
         leg1.render(scale);
@@ -40,7 +48,7 @@ public class ModelQuadruped extends ModelBase
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
         head.xRot = headPitch / 57.29578F;
         head.yRot = headYaw / 57.29578F;
@@ -50,11 +58,4 @@ public class ModelQuadruped extends ModelBase
         leg3.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
         leg4.xRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
     }
-
-    public Cube head;
-    public Cube body;
-    public Cube leg1;
-    public Cube leg2;
-    public Cube leg3;
-    public Cube leg4;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelScorpion.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelScorpion.java
index c3c869bed..698b7635d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelScorpion.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelScorpion.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class ModelScorpion extends ModelBase
@@ -82,9 +84,9 @@ public class ModelScorpion extends ModelBase
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
 
         GL11.glPushMatrix();
         GL11.glTranslatef(0, 1.4F, 0);
@@ -105,7 +107,7 @@ public class ModelScorpion extends ModelBase
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
         legLFront.setRotationAngle(0.0F, -2.618F, 0.3927F);
         legLMid.setRotationAngle(0.0F, 3.1416F, 0.3927F);
